import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class ControlCanvas extends ScaleCanvas implements MouseListener,KeyListener, MouseMotionListener {
    Manager M;
    ControlPanel SHOW,RESET,ACTION;      
    ConfigurationControl CC1;
    BoxStatistics BS;
    Point JX;
    SliceComputer HC;
    SelectInteger CONFINE1,CONFINE2,GRID;
    EnergyEntry ENERGY;   
    Anneal ANN;     
    Proof PROOF;    
    SanityChecks SC;
    ProofControl PC;
    SliceControl HCON;
    SanityCheckControl SCC;
    ListenSquare GO,HALT;     
    Documentation DOC;
    ListenSquare[] INFO=new ListenSquare[50];


     public ControlCanvas addManager(Manager M) {
	ControlCanvas PP=this;
	PP.M=M;
	return(PP);
    }

     public ControlCanvas() {
	 addKeyListener(this);
	 addMouseListener(this);
	 addMouseMotionListener(this);

	 setControlPanels();	 	 
                   setButtons();

	 HC=new SliceComputer();
                   ANN=new Anneal();	 
                   PROOF=new Proof();   
                   SC=new SanityChecks();
	 BS=new BoxStatistics();

	 PC=new ProofControl(120,5);
                   SCC=new SanityCheckControl(120,5);
                   CC1=new ConfigurationControl(220,660);	  
                   HCON=new SliceControl(120,5);
     }

    public void setButtons() {
	GO=new ListenSquare(5,330,25,20,Color.red); GO.on=1;
	HALT=new ListenSquare(5,355,30,20,Color.red); HALT.on=1;	
	INFO[0]=new ListenSquare(98,330,12,12,Color.red); 
	INFO[1]=new ListenSquare(98,405,12,12,Color.red); 
	INFO[2]=new ListenSquare(98,580,12,12,Color.red);   //grid 
	INFO[3]=new ListenSquare(98,660,12,12,Color.red);   //emergy display
	INFO[4]=new ListenSquare(365,276,12,12,Color.red);   //box stats
    }


    public void setControlPanels() {

      Color[] C0={new Color(50,100,255),Color.white,Color.white,Color.black,Color.red};

      String[] ActionString={"evolve","proof","slice","checker","action"};
      int[] ActionState={1,0,0,0};
      ACTION=new ControlPanel(C0,ActionString,ActionState,4);
      ACTION.INFO_LIVE=1;

      String[] ShowString={"min1","min2","min3","min4","grid","unit circle","inverted","proof update","solids","display"};
      int[] ShowState={0,0,0,0,1,1,0,0,1};
      SHOW=new ControlPanel(C0,ShowString,ShowState,9);
      SHOW.INFO_LIVE=1;

      String[] ConfigString={"min1","min2","sqbase","random","dyadic","reset"};
      int[] ConfigState={0,0,0,0,0};
     RESET=new ControlPanel(C0,ConfigString,ConfigState,5);
     RESET.INFO_LIVE=1;

     CONFINE1=new SelectInteger(5,405,40,20,2,0,20,1);
     CONFINE2=new SelectInteger(5,455,40,20,2,0,20,1);
     GRID=new SelectInteger(5,580,40,20,2,-1,5,1);
     ENERGY=new EnergyEntry(5,658);
    }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      makeFrame(g);
      g.setFont(new Font("Helvetica",Font.PLAIN,12));
      drawPanels(g);    
      drawButtons(g);
      drawStatistics(g);
   }
 
    public void drawStatistics(Graphics2D g) {
	if(PROOF.halt==0) {
	    BS=new BoxStatistics(M.P.getBC(0),ENERGY.getParameter(),CC1.on1,CONFINE1.val,CONFINE2.val,CC1.DYADIC.on);
                      BS.render(g);
	    INFO[4].infoRenderLive(g);
	}
   }   

    public void makeFrame(Graphics2D g) {
    g.setColor(new Color(50,0,50));
      g.fillRect(0,0,getWidth(),getHeight()); 	
      g.setColor(Color.black);
      g.fillRect(0,5,115,795);
      g.setColor(new Color(255,0,255));
     g.drawRect(0,5,115,795);
     g.setFont(new Font("Helvetica",Font.PLAIN,24));
     g.drawString("Electron Champ", 390,200);
     g.setFont(new Font("Helvetica",Font.PLAIN,18));
     g.drawString("Rich Schwartz", 390,235);

    }

    public void drawButtons(Graphics2D g) {
      GO.render(g,new Color(0,180,0));
      g.drawString("go",8,340);
      if(SC.halt+ANN.halt+HC.halt+PROOF.halt>0)     {
             HALT.render(g,Color.red);
             g.drawString("stop",8,365);
      }

      for(int i=0;i<5;++i) INFO[i].infoRenderLive(g);
    }

  public void drawPanels(Graphics2D g) {
       ACTION.render(g,5,240,105);
       SHOW.render(g,5,10,105);    
       RESET.render(g,5,700,105);    
       CONFINE1.render(g,Color.red,Color.white,Color.white);
       CONFINE2.render(g,Color.red,Color.white,Color.white);
       GRID.render(g,Color.red,Color.white,Color.white);
       g.setColor(Color.white);
       g.drawString("confine diameter",5,400);
       g.drawString("grid display",5,575);
       CC1.render(g);
       ENERGY.render(g);
       if(ACTION.mode==1) PC.render(g);
       if(ACTION.mode==2) HCON.render(g);
       if(ACTION.mode==3) SCC.render(g);
  }






  public void updatePanels(Point X) {    
                  DOC=new Documentation();
	DOC.M=this.M;
	int test=SHOW.toggle(X);
	if(test==20) DOC.displayInfo();
	CONFINE1.modify(X);
	CONFINE2.modify(X);
	GRID.modify(X);
	test= ACTION.switchMode(X);	
                  if(test==20) DOC.actionInfo();
	int choice=CC1.SELECT.mode;
	int val=RESET.getValue(X);
	if(val==20) DOC.resetInfo();
	if(val==choice) M.P.Z[choice]=Configuration.configuration1();
	if(val==1) M.P.Z[choice]=Configuration.configuration2();
	if(val==2) M.P.Z[choice]=Configuration.configuration3();
	if(val==3) M.P.Z[choice]=Configuration.randomPoints();
	if(val==4) M.P.Z[choice]=Configuration.dyadic(M.P.Z[choice],CC1.size[choice]);
	if(INFO[0].inside(X)==1) DOC.goInfo();
	if(INFO[1].inside(X)==1) DOC.confineInfo();
	if(INFO[2].inside(X)==1) DOC.gridInfo();
	if(INFO[3].inside(X)==1) DOC.exponentInfo();
	if(INFO[4].inside(X)==1) DOC.statsInfo();

  }
     public void doRun() {
	int mode=ACTION.mode;
	if((mode==0)&&(ANN.halt==0))  {
	     ANN=new Anneal(this.M);
	     new Thread(ANN).start();
	}

	if((mode==1)&&(PROOF.halt==0)) {
                       PROOF=new Proof(this.M);
	     new Thread(PROOF).start();
	}

	if((mode==2)&&(HC.halt==0)) {
                       HC=new SliceComputer(this.M);
	     new Thread(HC).start();
	}

	if((mode==3)&&(SC.halt==0)) {
                       SC=new SanityChecks(this.M);
	     new Thread(SC).start();
	}
    }

    public void doStop() {
	ANN.halt=0;
	SC.halt=0;
	HC.halt=0;
	PROOF.halt=0;
    }
    
    public void doDyadic() {
	if(CC1.DYADIC.on==1) M.P.Z[0]=Configuration.dyadic(M.P.Z[0],CC1.size[0]);
    }

    public void proofProcess(Point X) {
                      int test=PC.process(X);
    }


    public void mouseClicked(MouseEvent e) { 
        MouseData J=MouseData.process(e);
        updatePanels(J.X);	
        if(GO.inside(J.X)==1) doRun();
        if(HALT.inside(J.X)==1) doStop();
        if(ACTION.mode==1) proofProcess(J.X);   
        if(ACTION.mode==2) HCON.process(J.X);
        if(ACTION.mode==3) SCC.process(J.X);

        int test=CC1.process(J.X,J.mode);   
         if(test==19) DOC.configurationInfo();
         if(test==20) DOC.confinerInfo();
        if(test==1) doDyadic(); 
        ENERGY.processMouse(J.X);	
        repaint();
        M.P.repaint();
    }

    public void doMouseClick(Point X,int mode) {
        updatePanels(X);	
        if(GO.inside(X)==1) doRun();
        if(HALT.inside(X)==1) doStop();
        if(ACTION.mode==1) proofProcess(X);
        if(ACTION.mode==2) HCON.process(X);
        if(ACTION.mode==3) SCC.process(X);
        int test=CC1.process(X,mode);         
        if(test==1) doDyadic(); 
        ENERGY.processMouse(X);	
        repaint();
        M.P.repaint();
    }

    public void mousePressed(MouseEvent e) {}
     public void mouseReleased(MouseEvent e) {}
     public void mouseEntered(MouseEvent e) {
	 requestFocus();
     }
     public void mouseExited(MouseEvent e) {}   
     public void mouseDragged(MouseEvent e) {
     } 

     public void mouseMoved(MouseEvent e) {
	try{
	    MouseData J=MouseData.process(e);
	    JX=J.X;
	}
	catch(Exception ee) {}
     }


    public void keyTyped(KeyEvent e) {
                  ENERGY.processKey(e);
	int test=0;
	char ch=e.getKeyChar();
	if(ch=='z') test=1;
	if(ch=='x') test=2;
	if(ch=='c') test=3;
	if(test>0) doMouseClick(JX,test);
	repaint();
    }
 
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}



}

