import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class DocumentPictureWindow {
    Manager M;
    public DocumentPictureWindow(Manager MM) {
	this.M=MM;
    }

    public void pictureInfo() {

      String S="Picture Window";

      S=S+"\n\nThis window displays a configuration of 3 squares and 1 interval.  These squares serve two purposes.  First, the centers of these objects represent an electron configuration of 5 points.  Second the product of the interval and the squares represents what we call a dyadic box in the paper.  A dyadic box is a 7-dimensional rectangular solid, a subset of the configuration space.";

      S=S+"\n\nThe 4 centers, together with the point at infinity, give 5 points in the Riemann sphere.  Inverse stereographic projection maps these 5 points to 5 points on the unit sphere.  This is how the representation works.";

      S=S+"\n\nYou can modify various parts of the display, as follows:\n\n--A left mouse click scales the window up.\n\n--A right mouse click scales the window down.\n\n--Clicking/dragging with the middle mouse button moves the configuration.  Note that the yellow segment must stay on the real like between 1 and 3. \n\n--Left/right clicking on the colored disks in the configuration control panel changes the sizes of the squares.   The number k corresponds to a sidelength of 2^(-k).";

      S=S+"\n\nYou can display various auxilliary objects in the picture window.  To see what these objects are, click on the documentation for the 'display' control panel.";


	M.E.setExplain(S);
	M.E.repaint();
  }

    public void configurationInfo() {

      String S="Configuration Control";

      S=S+"\n\nThis window controls some features of the point configuration you see in the Picture Window.   Here is a list of features.";

      S=S+"\n\nThe 4 colored disks control the 4 points in the Picture Window.  If you left/right click on the disks, you change the sizes of the squares centered at the points.  If the disk has a k in it, the side length of the corresponding square is 2^(-k).  If you middle click on one of these disks, you deactivate the point. This feature is only relevant for the 'evolve' feature of the program.  A deactivated point will be frozen during the annealing process that tries to lower the energy of a configuration.";

      S=S+"\n\nYou need a 3 button mouse to operate the disk controls we have just mentioned.  If you don't have a 3 button mouse, however, you can use the keys Z, X, and C.  These are printed in blue on the control panel to remind you of this shortcut.";

      S=S+"\n\nThe box size arrow keys let you change all the square sizes at the same time.";
      S=S+"\n\nIf you click on the thick line segments connecting the disks, you can activate (pink) or deactivate (blue) a 'bond' between a pair of points in the configuration.  On the right hand side of the program, called CONFIGURATION STATS, one of the listings is called 'energy,bond'.  This item computes the total energy of the configuration computed from the activated bonds.  So, you can compute these energies in various combinations by turning on and off the bonds.  This feature has nothing to do with the proof, but we thought it would be useful for experimentation.  The proof runs, of course, with all bonds activated.";

      S=S+"\n\nThe 'reset bonds' button uniformly activates or deactivates the bonds.";

      S=S+"\n\nThe 'dyadic' button, when active (yellow) forces the selected points in the configuration to lie at dyadic rational points.  The proof only considers such configurations.";

	M.E.setExplain(S);
	M.E.repaint();
  }


    public void confinerInfo() {

	String S="Confiner Toggle";

	S=S+"\n\nThis control panel toggles between two options.  When you are are in 'regular mode' you are controlling the basic configuration.  The statistics for this configuration (energy) are displayed on the right hand side of the main control panel.";

	S=S+"\n\nWhen you are in 'confiner mode', you are selecting a special configuration that is used with one of the advanced modes of the proof.    The basic mode of our proof explores the whole configuration space.  In the advanced 'confined' mode of the proof, you can just explore a portion of the configuration space.   You select the subset to consider using the 'confiner mode' of this control panel.   The 'confined' mode of the proof automatically eliminates a dyadic box if the corresponding squares and segment do not intersect the configuration you select in this mode.";

	M.E.setExplain(S);
	M.E.repaint();
  }












}


