import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

/**Interval version of stereographic projection**/

public class IntervalStereo {

    public static IntervalVector inverseStereo(IntervalComplex z) {
	Interval ONE=new Interval(1.0,1.0);
	Interval TWO=new Interval(2.0,2.0);
	Interval d=new Interval(ONE);
	d=Interval.plus(d,Interval.times(z.x,z.x));
	d=Interval.plus(d,Interval.times(z.y,z.y));
	Interval a=Interval.divide(Interval.times(TWO,z.x),d);
	Interval b=Interval.divide(Interval.times(TWO,z.y),d);
	Interval c=Interval.minus(ONE,Interval.divide(TWO,d));
	IntervalVector v=new IntervalVector(a,b,c);
	return(v);
    }

    public static IntervalComplex stereo(IntervalVector V) {
	Interval ONE=new Interval(1.0,1.0);
	Interval a=Interval.divide(V.x[0],Interval.minus(ONE,V.x[2]));
	Interval b=Interval.divide(V.x[1],Interval.minus(ONE,V.x[2]));
	return(new IntervalComplex(a,b));
    }


}


