import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

public class LinearAlgebra {


    /**This routine uses the square-root-free modified version of the
          Cholesky decomposition to test whether a symmetric real
          matrix is positive definite.  The sufficient condition is that all the 
          D values are positive. **/


    public static int testPositiveDefinite(int N,double[][] A) {
	double[][] L=new double[N][N];
	double[] D=new double[N];

	D[0]=A[0][0];
	for(int i=0;i<N;++i) L[i][i]=1;

	for(int j=0;j<N;++j) {
	    for(int i=j+1;i<N;++i) {

	    double s=0;
	    for(int k=0;k<j;++k) {
		s=s+L[i][k]*L[j][k]*D[k];
	    }
	    L[i][j]=(A[i][j]-s)/D[j];

	    s=0;
	    for(int k=0;k<i;++k) {
	       s=s+L[i][k]*L[i][k]*D[k];
	    }
	    D[i]=A[i][i]-s;


	    }}

	for(int i=0;i<N;++i) {
	    if(D[i]<0) return(0);
	}
	return(1);
    }

    /**This routine tests whether the smallest eigenvalue of a real symmetric
       matrix exceeds lambda**/

    public static int testLowestEigenvalue(int N,double[][] A,double lambda) {
	double[][] B=new double[N][N];
	for(int i=0;i<N;++i) {
	    for(int j=0;j<N;++j) {
		B[i][j]=A[i][j];
	    }
	}
	for(int i=0;i<N;++i) {
	    B[i][i]=B[i][i]-lambda;
	}
	return(testPositiveDefinite(N,B));
    }


    public static double findLowestEigenvalue(int N,double[][] A) {

	double e1=-100;
	double e2=0;
	double e3=100;
	int test=1;
	while(test==1) {
	    e2=(e1+e3)/2;
	    int test2=testLowestEigenvalue(N,A,e2);
	    if(test2==1) e1=e2;
	    if(test2==0) e3=e2;
	    if(Math.abs(e1-e3)<.00000001) test=0;
	}
	return(e2);
    }


}

