import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

/**This is the redundancy eliminator from the paper*/

public class RedundancyEliminator {

    /**The main routine**/

    public static int eliminate(double E,BoxConfiguration X) {
	if(isInverted(X)==1) return(1);       //property 3
 	if(isPermuted(X)==1) return(1);     //property 2
	if(bondTooHi(E,X)==1) return(1);  //property 1
	return(0);
    }

    /**Property 1**/

    public static int bondTooHi(double E,BoxConfiguration X) {

	Vector[] V1=X.B[0].toVectors();
	Vector V2=new Vector(0,0,1);
	double min=Vector.dist(V1[1],V2);   

	for(int i=0;i<4;++i) {
	    for(int j=i+1;j<5;++j) {
	      if((i!=0)||(j!=4)) {
		  double psi_max=Separation.psiMax(X.B[i],X.B[j]);
		  if(psi_max<min) return(1);
	      }
	    }
	}
	return(0);
    }	

    /**Property 2**/

    /************returns 1 if the boxes are out of order.   The correct order is
                             B3 top,  B0 middle,  B2 bottom  **/



    public static int isPermuted(BoxConfiguration X) {
	if(X.B[1].yMin()>=X.B[2].yMax()) return(1);
	if(X.B[2].yMin()>=X.B[3].yMax()) return(1);
	if(X.B[2].yMax()<=0) return(1);
	if(X.B[1].yMin()>=0) return(1);
	if(X.B[0].xMax()<=1) return(1);
	return(0);
    }


    /**Property 3**/

    public static int isInverted(BoxConfiguration X) {
	if(X.B[1].yMax()>=0) return(0);
	if(X.B[3].yMin()<=0) return(0);
	if(X.B[2].xMaxDouble()<1-Math.sqrt(2)) return(1);
	return(0);
    }

}

