import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

public class SanityCheckControl {
    int X,Y;
    SelectInteger[] SI=new SelectInteger[10];
    double[] d=new double[2];
    double[][] dd=new double[5][5];
    ControlPanel ACTION;

    public SanityCheckControl(int XX,int YY) {
	X=XX;
	Y=YY;
	SI[1]=new SelectInteger(X+10,Y+203,40,20,0,0,2,1);  //MODE TOGGLE
	SI[2]=new SelectInteger(X+10,Y+260,30,15,2,1,12,1);  //box size
	SI[3]=new SelectInteger(X+10,Y+280,30,15,2,2,8,1);  //  point sample density
	SI[4]=new SelectInteger(X+10,Y+300,30,15,2,2,10,1); //box sample density
	d[0]=0;
	d[1]=0;
	setControlPanels();
    }


    public void setControlPanels() {
        Color[] C0={new Color(50,100,255),Color.white,Color.white,Color.black,Color.red};
        String[] ActionString={"delta","max separation","min separation","vector geometry","energy theorem","real interval","complex interval","vector interval","stereographic","box routines","separation","energy","hessian","check"};
        int[] ActionState={1,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
        ACTION=new ControlPanel(C0,ActionString,ActionState,13);
    }

    public int getMode() {
	return(ACTION.mode);
    }

    public void render(Graphics2D g) {

	g.setColor(Color.black);
	g.fillRect(X,Y,200,430);
	g.setColor(new Color(255,0,255));
	g.drawRect(X,Y,200,430);
	renderDisplay(g);
	renderProgress(g);
	ACTION.render(g,X,Y,120);
    }


    public void renderProgress(Graphics2D g) {

	Double D1=new Double(d[1]);
	Integer I0=new Integer((int)(d[0]));
	g.drawString("amt. done",X+10,Y+380);	
                  g.drawString(I0.toString(),X+80,Y+380);
	g.drawString("min ratio",X+10,Y+400);
	g.drawString(D1.toString(),X+80,Y+400);

    }


     public void renderDisplay(Graphics2D g) {
	for(int i=2;i<5;++i)  SI[i].render(g,Color.blue,Color.white,Color.white);	

	int bs=SI[2].val;
	int d=0;
	d=(int)(Math.pow(2,2*bs+2));
	Integer D=new Integer(d);	
	g.drawString("box size"+"  ("+D.toString()+"  boxes)",X+70,Y+270);
	g.drawString("point scatter density",X+70,Y+290);
	g.drawString("box sample density",X+70,Y+310);
     }


    public void process(Point X) {	
                  for(int i=2;i<5;++i)
	SI[i].modify(X);
	ACTION.switchMode(X);
    }

}



