import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

/**This class has routines that help facilitate the sanity checks.**/

public class SanityCheckSupport {





    /**These routines start with a list of dyadic squares or segments and
          produce a new list by subdividing each square into squares of half the size.
          The new list is twice as long if we have a list of segments, and 4 times
          as long if we have a list of squares **/

    public static Box[] getBoxList(Box INITIAL,int t) {
	Box[] B1=new Box[1];
	B1[0]=new Box(INITIAL);
	for(int i=0;i<t;++i) B1=subdivide(B1);
	return(B1);
    }


    public static Box[] subdivide(Box[] B) {
	int test=B[0].type;
	if(test==0) return(subdivide0(B));
	return(subdivide1(B));
    }

    /**squares**/
    public static Box[] subdivide0(Box[] B) {
	int len=B.length;
	Box[] C=new Box[4*len];
	int count=0;
	for(int k=0;k<len;++k) {
	    for(int i=0;i<4;++i) {
	         C[count]=B[k].subdivide0(i);
	         ++count;
	    }
	}
	return(C);
    }

    /**segments**/

    public static Box[] subdivide1(Box[] B) {
	int len=B.length;
	Box[] C=new Box[2*len];
	int count=0;
	for(int k=0;k<len;++k) {
	    for(int i=0;i<2;++i) {
	        C[count]=B[k].subdivide1(i);
		++count;
	    }
	}

	return(C);
    }



}



