import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class SliceCanvas extends ScaleCanvas implements  KeyListener, MouseListener, MouseMotionListener {
    Manager M;  
    Point JX; 
    double[][] val=new double[1024][1024];
    int MESH;

     public SliceCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);	 
                   addKeyListener(this);
	 setScales(0,400,200);
	 initValues();	
	 MESH=2;
     }


    public SliceCanvas addManager(Manager M) {
	SliceCanvas PP=this;
	PP.M=M;
	return(PP);
    }

    public void initValues() {
	for(int i=0;i<256;++i) {
	    for(int j=0;j<256;++j) {
		val[i][j]=0;
	    }
	}
    }


   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      plotValues(g);     
      drawFrame(g);
   }

    public GeneralPath makeFrame() {
	GeneralPath gp=new GeneralPath();
	float a1=(float)(0.5);
	float a2=(float)(1.5);
	gp.moveTo(a1,a1);
	gp.lineTo(a1,a2);
	gp.lineTo(a2,a2);
	gp.lineTo(a2,a1);
	gp.closePath();
	gp=transform(gp);
	return(gp);
    }

    public void drawBG(Graphics2D g) {
	g.setColor(new Color(50,0,50));
	g.fillRect(0,0,getWidth(),getHeight());
	GeneralPath gp=makeFrame();
	g.setColor(Color.black);
	g.fill(gp);

    }

    public void drawFrame(Graphics2D g) {
	GeneralPath gp=makeFrame();
	g.setColor(Color.white);
	g.draw(gp);	
                  drawSquare(g,Color.red,Color.white,new Complex(1,1),.004);
	drawSquare(g,Color.yellow,Color.yellow,new Complex(1,Math.sqrt(1.0/3.0)),.004);
	drawSquare(g,Color.yellow,Color.yellow,new Complex(Math.sqrt(1.0/3.0),1),.004);
	drawSource(g);
    }




    public void plotValues(Graphics2D g) {
	Color[] C={new Color(0,0,100),new Color(0,0,150),new Color(0,0,200),new Color(0,0,255),new Color(50,100,255),new Color(255,0,0),new Color(255,50,0),new Color(255,150,0),new Color(255,255,0),new Color(255,255,255)};
	int m=(int)(Math.pow(2,MESH));
	double r=Math.pow(2,-MESH);
	r=r*.45;
	for(int i=0;i<m;++i) {
	    for(int j=0;j<m;++j) {
		double ii=1.0*i/m+0.5/m;
		double jj=1.0*j/m+0.5/m;
		double x=(1-ii)*.5+ii*1.5;
		double y=(1-jj)*.5+jj*1.5;
		Color CC=Color.black;
		if(val[i][j]>=0) CC=C[(int)(val[i][j])];
		if(val[i][j]<0) CC=Color.white;
		drawSquare(g,CC,CC,new Complex(x,y),r);
	    }
	}

    }


    public void transfer() {
	M.P.Z[0]=Configuration.symmConfig(SOURCE);
    }


    public void mousePressed(MouseEvent e) { }


    public void mouseClicked(MouseEvent e) {        
                  MouseData J=MouseData.process(e);
                       if(J.mode==3) scaleUp(J.X,1);
	    if(J.mode==1) scaleUp(J.X,-1);   
                       if(J.mode==2) {
		SOURCE=unTransform(J.X);
	    }
                  repaint();
    }

    public void doMouseClick(Point X,int mode) {        
                       if(mode==3) scaleUp(X,1);
	    if(mode==1) scaleUp(X,-1);
	    if(mode==2) {
	    SOURCE=unTransform(X);
	    }
                  repaint();
    }

     public void mouseReleased(MouseEvent e) {	 
     }

     public void mouseEntered(MouseEvent e) {
	 requestFocus();
     }

     public void mouseExited(MouseEvent e) {
     }

     public void mouseMoved(MouseEvent e) {
	try{
	    MouseData J=MouseData.process(e);
	    JX=J.X;
	}
	catch(Exception ee) {}
     }

     public void mouseDragged(MouseEvent e) {
     }


    public void keyTyped(KeyEvent e) {

	int test=0;
	char ch=e.getKeyChar();
	if(ch=='z') test=1;
	if(ch=='x') test=2;
	if(ch=='c') test=3;
	if(ch=='a') transfer();
	if(test>0) doMouseClick(JX,test);
	repaint();
	M.P.repaint();
    }


    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}

}

