import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

public class SliceComputer implements Runnable {
    int halt;
    Manager M;

    public SliceComputer() {
    }

    public SliceComputer(Manager MM) {
	this.M=MM;	
	halt=0;	
    }


    public void run() {	
	int mode=M.C.HCON.ACTION.mode;

	if(mode==0) {
	     hessianBound();
	}

	if(mode==1) {
	     hessianSurvey();
	}

	if(mode==2) {
	     valueSurvey();
	}

	if(mode==3) {
	    hessianCompute();
	}
	halt=0;
	M.C.repaint();
    }


    public void hessianBound() {
	halt=1;
	int a1=M.C.HCON.SI[1].val;
	int a2=M.C.HCON.SI[2].val;
	int a3=M.C.HCON.SI[3].val;
	double E=M.C.ENERGY.getParameter();

	double r1=Math.pow(.5,a1+1);  //confine diameter
	int r2=(int)(Math.pow(2,a2-1));  //point sample density
	double r3=Math.pow(.5,a3);  //positivity tolerance
	double[] x={1,0,0,-.5,Math.sqrt(3.0)/2,-.5,-Math.sqrt(3.0)/2};  //TBP
	double[] y=new double[7];

	for(int i0=-r2;i0<r2;++i0) {
	for(int i1=-r2;i1<r2;++i1) {
	for(int i2=-r2;i2<r2;++i2) {
	    System.out.println(i0+" "+i1+" "+i2);
	for(int i3=-r2;i3<r2;++i3) {
	for(int i4=-r2;i4<r2;++i4) {
	for(int i5=-r2;i5<r2;++i5) {
	for(int i6=-r2;i6<r2;++i6) {

	    int[] N={i0,i1,i2,i3,i4,i5,i6};
	    for(int j=0;j<7;++j) {
		y[j]=x[j]+r1/r2*N[j];
	    }
	    double[][] h=Hessian.hessian(E,y);
	    int t=LinearAlgebra.testLowestEigenvalue(7,h,r3);
	    if(t==0)  System.out.println("fail");

	}}}}}}}
	halt=0;
	M.C.repaint();
    }




    public void hessianCompute() {
	halt=1;
	Complex[][] Z=M.P.Z;
	for(int i=0;i<4;++i) Z[0][i].print();

	double E=M.C.ENERGY.getParameter();
	double[] x={Z[0][0].x,Z[0][1].x,Z[0][1].y,Z[0][2].x,Z[0][2].y,Z[0][3].x,Z[0][3].y};
	double[][] h=Hessian.hessian(E,x);
	double test=LinearAlgebra.findLowestEigenvalue(7,h);
	System.out.println("test "+test);
	halt=0;
    }

    public void hessianSurvey() {
	halt=1;
	int m=M.C.HCON.SI[2].val;
	M.S.MESH=m;
	double mesh=Math.pow(2,m);
                  double E=M.C.ENERGY.getParameter();	
                  int a3=M.C.HCON.SI[3].val;
	double tol=Math.pow(.5,a3);  //positivity tolerance


	for(int i=0;i<mesh;++i) {
	    for(int j=0;j<mesh;++j) {
		double x=1.0*i/mesh+.5/mesh;
		double y=1.0*j/mesh+.5/mesh;
		x=x+.5;
		y=y+.5;
		Complex[] Z=Configuration.symmConfig(new Complex(x,y));
   	                  double[] X={Z[0].x,Z[1].x,Z[1].y,Z[2].x,Z[2].y,Z[3].x,Z[3].y};
	                  double[][] h=Hessian.hessian(E,X);
		int t2=0;
		for(int k=2;k<11;++k) {
		    int t1=LinearAlgebra.testLowestEigenvalue(7,h,Math.pow(.5,k));
		     if(t1==1) ++t2;
		}
		M.S.val[i][j]=t2;
	    }
	}
	M.S.repaint();
	halt=0;
    }




    public void valueSurvey() {
	halt=1;
	int m=M.C.HCON.SI[2].val;
 	int sen=M.C.HCON.SI[3].val;
	M.S.MESH=m;
	double mesh=Math.pow(2,m);
                  double E=M.C.ENERGY.getParameter();	     
                  double TBPEnergy=Energy.minEnergy(E);
                  int a3=M.C.HCON.SI[3].val;

	for(int i=0;i<mesh;++i) {
	    for(int j=0;j<mesh;++j) {
		double x=1.0*i/mesh+.5/mesh;
		double y=1.0*j/mesh+.5/mesh;
		x=x+.5;
		y=y+.5;
		Complex[] Z=Configuration.symmConfig(new Complex(x,y));
                                    double test=Energy.energy(E,Z);
		test=test-TBPEnergy;
		int t2=0;
		for(int k=2;k<11;++k) {
		    if(test>Math.pow(2,-k-sen)) ++t2;
		}
		M.S.val[i][j]=t2;
		if(test<0) M.S.val[i][j]=-1;
	    }
	}
	M.S.repaint();
	halt=0;
    }





}