import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

public class SliceControl {
    int X,Y;
    SelectInteger[] SI=new SelectInteger[10];
    double[] d=new double[2];
    double[][] dd=new double[5][5];
    ControlPanel ACTION;

    public SliceControl() {}

    public SliceControl(int XX,int YY) {
	X=XX;
	Y=YY;
	SI[1]=new SelectInteger(X+10,Y+10,30,15,8,1,14,1);  //confine neighborhood
	SI[2]=new SelectInteger(X+10,Y+30,30,15,2,2,10,1);  //  point sample density
	SI[3]=new SelectInteger(X+10,Y+50,30,15,4,0,12,1); //tolerance
	d[0]=0;
	d[1]=0;
	setPanels();
    }

    public void setPanels() {
      Color[] C0={new Color(50,100,255),Color.white,Color.white,Color.black,Color.red};
      String[] ActionString={"TBP hessian","slice hessian","slice energy","current hessian","choice"};
      int[] ActionState={1,0,0,0};
      ACTION=new ControlPanel(C0,ActionString,ActionState,4);
      ACTION.INFO_LIVE=1;
    }



    public void render(Graphics2D g) {

	g.setColor(Color.black);
	g.fillRect(X,Y,200,200);
	g.setColor(new Color(255,0,255));
	g.drawRect(X,Y,200,200);
	ACTION.render(g,X,Y+100,100);
	if(ACTION.mode==0) renderDisplay(g);
	if(ACTION.mode==1) renderDisplay(g);
	if(ACTION.mode==2) renderDisplay(g);

    }

     public void renderDisplay(Graphics2D g) {
	for(int i=1;i<4;++i)  SI[i].render(g,Color.blue,Color.white,Color.white);	
	String[] ST=new String[3];

	for(int i=0;i<3;++i) ST[i]="";

	if(ACTION.mode==0) {
	    ST[0]="confine side length";
	    ST[1]="sample density";
	    ST[2]="positivity tolerance";
	}

	if(ACTION.mode==1) {
	    ST[0]="no function";
	    ST[1]="sample density";    
                      ST[2]="no function";
	}

	if(ACTION.mode==2) {
	    ST[0]="no function";
	    ST[1]="sample density";    
                      ST[2]="sensitivity";
	}


	for(int i=0;i<3;++i) {
	    g.drawString(ST[i],X+70,Y+20+20*i);
	}
     }


    public void process(Point X) {	
                  for(int i=1;i<4;++i)
	SI[i].modify(X);
	ACTION.switchMode(X);
    }

}



